import ktc
import numpy as np
import os
import onnx
from PIL import Image

onnx_path = '/docker_mount/yolov5/yolov5s.onnx'
m = onnx.load(onnx_path)
#m = ktc.onnx_optimizer.onnx2onnx_flow(m)

import kneronnxopt

optimized_model = kneronnxopt.optimize(m)

onnx.save(optimized_model, '/docker_mount/yolov5/yolov5s.opt.onnx')

# npu (only) performance simulation
km = ktc.ModelConfig(20005, "0003", "720", onnx_model=optimized_model)
eval_result = km.evaluate()
print("\nNpu performance evaluation result:\n" + str(eval_result))

import os
from os import walk

img_list = []
for (dirpath, dirnames, filenames) in walk("/docker_mount/yolov5/data/images"):
    for f in filenames:
        fullpath = os.path.join(dirpath, f)
        
        image = Image.open(fullpath)
        image = image.convert("RGB")
        image = Image.fromarray(np.array(image)[...,::-1])
        img_data = np.array(image.resize((640, 640), Image.BILINEAR)) / 256 - 0.5
        print(fullpath)
        img_list.append(img_data)

output_dir = '/docker_mount/nef_730_result/yolov5'

img_list_nchw = [np.transpose(img, (2, 0, 1))[np.newaxis, :] for img in img_list]
# fixed-point analysis
bie_model_path = km.analysis({"images": img_list_nchw}, output_dir = output_dir)
print("\nFixed-point analysis done. Saved bie model to '" + str(bie_model_path) + "'")

# compile
nef_model_path = ktc.compile([km], output_dir = output_dir)
print("\nCompile done. Saved Nef file to '" + str(nef_model_path) + "'")
